---
name: "Bug Report"
about: "Open a bug report to help us identify issues with Terra."
title: "[Bug] <Put your title here>"
labels: "Type: Bug, Status: Pending"
assignees: ""

---

<!--
##############################################################################
## WARNING!                                                                 ##
## IGNORING THE FOLLOWING TEMPLATE WILL RESULT IN YOUR ISSUE BEING CLOSED   ##
##############################################################################
-->

## Pre-Issue Checklist

<!--
  Please go through this checklist item by item and make sure you have successfully completed each of these steps.
    - You must be on the LATEST version of Terra to receive any support. There is no support for older versions of Terra.
    - Make sure that this is not a *specific* compatibility issue with another terrain generation mod.
        Do not request *specific* compatibility with mods or plugins (e.g. "Compatibility with TechCraft v7").
        That should be implemented in an addon, **not** in the main project.
        *General* compatibility (e.g. "Ability to pull Vanilla/Modded features from parent biomes") will be considered in the main project.
    - Make sure that there are no already existing issues open with your problem. If you open a duplicate, it will be closed as such.
    - Make sure that it is actually Terra causing the issue, and not another mod/plugin.
        You can do this by testing to see if you can recreate the issue without Terra installed.
    - Make sure that this is not an issue with a specific Terra *pack* or Terra *addon*, and instead applies to all of Terra.
    - Make sure that you attach a copy of the latest.log file.
        Putting *just* the exception IS NOT ENOUGH. We need to be able to check that there wasn't anything else before that caused it.
    - Make sure that you have filled out all the required information and given descriptions of everything.
    
    You must put an x in all the boxes you have completed. (Like this: [x])
    
    To make sure that your issue is rendered properly, you may check the "Preview" tab (below the title) to see a rendered version of it before you submit it.
-->

- [ ] I have checked that I am on the latest version of Terra.
- [ ] I have searched the github issue tracker for similar issues, including
  closed ones.
- [ ] I have made sure that this is not a bug with another mod or plugin, and it
  is Terra that is causing the issue.
- [ ] I have checked that this is an issue with Terra and not an issue with the
  pack I am using.
  <!-- If this is an issue with the default Terra pack, please open an issue on the pack repo: https://github.com/PolyhedralDev/TerraOverworldConfig/issues/new -->
- [ ] I have attached a copy of the `latest.log` file
- [ ] I have filled out and provided all the appropriate information.

## Environment

<!-- You can fill out the different items by putting the correct value beside each cell. -->

| Name                         | Value                                                                                                                                                                       |
|------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Terra Version                | <!-- Put your Terra version here. (remove the comment) -->                                                                                                                  
| Platform / Platform Version  | <!-- Put your platform and platform version here. (remove the comment) (eg. Spigot, Fabric, Paper, etc.) (If you are using the Region generator, put that here instead) --> 
| Any External Plugins or Mods | <!-- Put a list of all the plugins or mods you have installed here. (remove the comment) (Make sure to NOT include any new lines) -->                                       
| Terra Packs In Use           | <!-- Put a list of all the Terra packs you have installed here. (remove the comment) (Make sure to NOT include any new lines) (/te packs may be used to get a list) -->     
| Terra Addons In Use          | <!-- Put a list of all the Terra addons you have installed here. (remove the comment) (Make sure to NOT include any new lines) (/te addons may be used to get a list) -->   

## Issue Description

<!--
    Put a quick description of the issue here.
    Example: 'When generating terrain, something causes the chunks to not load properly', etc.
-->

### Steps to reproduce

<!--
    Describe what you were doing when this happened.
    Make sure to include ALL information. Including anything you were doing before that may have caused it.
-->

1. <!-- Put step #1 here. -->
2. <!-- Put step #2 here. -->
3. <!-- etc.              -->

### Expected behavior

<!-- Describe what you think *should* happen here: -->

### Actual behavior

<!-- Describe what *actually* happens here: -->
<!-- example: When I do _______, it actually does _______ -->

### Full stacktrace

<details>
<summary>Exception Stacktrace</summary>

<!--
If Terra logs an exception, please put it in the following section: (You will find any error logs in your console, or your latest.log)
Note: this *must* be included, in ADDITION to the latest.log file.
-->

```

```

</details>

### Additional details

<!-- Any other information you think should be added -->

